/*
* ============================================================================
* History
* =======
*
* (C) Copyright 2014, Future Technology Devices International Ltd.
* ============================================================================
*
* This source code ("the Software") is provided by Future Technology Devices
* International Limited ("FTDI") subject to the licence terms set out
* http://www.ftdichip.com/FTSourceCodeLicenceTerms.htm ("the Licence Terms").
* You must read the Licence Terms before downloading or using the Software.
* By installing or using the Software you agree to the Licence Terms. If you
* do not agree to the Licence Terms then do not download or use the Software.
*
* Without prejudice to the Licence Terms, here is a summary of some of the key
* terms of the Licence Terms (and in the event of any conflict between this
* summary and the Licence Terms then the text of the Licence Terms will
* prevail).
*
* The Software is provided "as is".
* There are no warranties (or similar) in relation to the quality of the
* Software. You use it at your own risk.
* The Software should not be used in, or for, any medical device, system or
* appliance. There are exclusions of FTDI liability for certain types of loss
* such as: special loss or damage; incidental loss or damage; indirect or
* consequential loss or damage; loss of income; loss of business; loss of
* profits; loss of revenue; loss of contracts; business interruption; loss of
* the use of money or anticipated savings; loss of information; loss of
* opportunity; loss of goodwill or reputation; and/or loss of, damage to or
* corruption of data.
* There is a monetary cap on FTDI's liability.
* The Software may have subsequently been amended by another user and then
* distributed by that other user ("Adapted Software").  If so that user may
* have additional licence terms that apply to those amendments. However, FTDI
* has no liability in relation to those amendments.
* ============================================================================
*/

#ifndef _FT_COPRO_CMDS_H_
#define _FT_COPRO_CMDS_H_

ft_void hal_spi_cmd_text(ft_int16_t x, ft_int16_t y, ft_int16_t font, ft_uint16_t options, const ft_char8_t* s);
ft_void hal_spi_cmd_number(ft_int16_t x, ft_int16_t y, ft_int16_t font, ft_uint16_t options, ft_int32_t n);
ft_void hal_spi_cmd_loadidentity();
ft_void hal_spi_cmd_toggle(ft_int16_t x, ft_int16_t y, ft_int16_t w, ft_int16_t font, ft_uint16_t options, ft_uint16_t state, const ft_char8_t* s);
ft_void hal_spi_cmd_gauge(ft_int16_t x, ft_int16_t y, ft_int16_t r, ft_uint16_t options, ft_uint16_t major, ft_uint16_t minor, ft_uint16_t val, ft_uint16_t range);
ft_void hal_spi_cmd_regread(ft_uint32_t ptr, ft_uint32_t result);
ft_void hal_spi_cmd_getprops(ft_uint32_t ptr, ft_uint32_t w, ft_uint32_t h);
ft_void hal_spi_cmd_memcpy(ft_uint32_t dest, ft_uint32_t src, ft_uint32_t num);
ft_void hal_spi_cmd_spinner(ft_int16_t x, ft_int16_t y, ft_uint16_t style, ft_uint16_t scale);
ft_void hal_spi_cmd_bgcolor(ft_uint32_t c);
ft_void hal_spi_cmd_swap();
ft_void hal_spi_cmd_inflate(ft_uint32_t ptr);
ft_void hal_spi_cmd_translate(ft_int32_t tx, ft_int32_t ty);
ft_void hal_spi_cmd_stop();
ft_void hal_spi_cmd_slider(ft_int16_t x, ft_int16_t y, ft_int16_t w, ft_int16_t h, ft_uint16_t options, ft_uint16_t val, ft_uint16_t range);
ft_void hal_spi_cmd_interrupt(ft_uint32_t ms);
ft_void hal_spi_cmd_fgcolor(ft_uint32_t c);
ft_void hal_spi_cmd_rotate(ft_int32_t a);
ft_void hal_spi_cmd_button(ft_int16_t x, ft_int16_t y, ft_int16_t w, ft_int16_t h, ft_int16_t font, ft_uint16_t options, const ft_char8_t* s);
ft_void hal_spi_cmd_memwrite(ft_uint32_t ptr, ft_uint32_t num);
ft_void hal_spi_cmd_scrollbar(ft_int16_t x, ft_int16_t y, ft_int16_t w, ft_int16_t h, ft_uint16_t options, ft_uint16_t val, ft_uint16_t size, ft_uint16_t range);
ft_void hal_spi_cmd_getmatrix(ft_int32_t a, ft_int32_t b, ft_int32_t c, ft_int32_t d, ft_int32_t e, ft_int32_t f);
ft_void hal_spi_cmd_sketch(ft_int16_t x, ft_int16_t y, ft_uint16_t w, ft_uint16_t h, ft_uint32_t ptr, ft_uint16_t format);
ft_void hal_spi_cmd_memset(ft_uint32_t ptr, ft_uint32_t value, ft_uint32_t num);
ft_void hal_spi_cmd_calibrate(ft_uint32_t result);
ft_void hal_spi_cmd_setfont(ft_uint32_t font, ft_uint32_t ptr);
ft_void hal_spi_cmd_bitmap_transform(ft_int32_t x0, ft_int32_t y0, ft_int32_t x1, ft_int32_t y1, ft_int32_t x2, ft_int32_t y2, ft_int32_t tx0, ft_int32_t ty0, ft_int32_t tx1, ft_int32_t ty1, ft_int32_t tx2, ft_int32_t ty2, ft_uint16_t result);
ft_void hal_spi_cmd_gradcolor(ft_uint32_t c);
ft_void hal_spi_cmd_logo();
ft_void hal_spi_cmd_append(ft_uint32_t ptr, ft_uint32_t num);
ft_void hal_spi_cmd_memzero(ft_uint32_t ptr, ft_uint32_t num);
ft_void hal_spi_cmd_scale(ft_int32_t sx, ft_int32_t sy);
ft_void hal_spi_cmd_clock(ft_int16_t x, ft_int16_t y, ft_int16_t r, ft_uint16_t options, ft_uint16_t h, ft_uint16_t m, ft_uint16_t s, ft_uint16_t ms);
ft_void hal_spi_cmd_gradient(ft_int16_t x0, ft_int16_t y0, ft_uint32_t rgb0, ft_int16_t x1, ft_int16_t y1, ft_uint32_t rgb1);
ft_void hal_spi_cmd_setmatrix();
ft_void hal_spi_cmd_track(ft_int16_t x, ft_int16_t y, ft_int16_t w, ft_int16_t h, ft_int16_t tag);
ft_void hal_spi_cmd_getptr(ft_uint32_t result);
ft_void hal_spi_cmd_progress(ft_int16_t x, ft_int16_t y, ft_int16_t w, ft_int16_t h, ft_uint16_t options, ft_uint16_t val, ft_uint16_t range);
ft_void hal_spi_cmd_coldstart();
ft_void hal_spi_cmd_keys(ft_int16_t x, ft_int16_t y, ft_int16_t w, ft_int16_t h, ft_int16_t font, ft_uint16_t options, const ft_char8_t* s);
ft_void hal_spi_cmd_dial(ft_int16_t x, ft_int16_t y, ft_int16_t r, ft_uint16_t options, ft_uint16_t val);
ft_void hal_spi_cmd_loadimage(ft_uint32_t ptr, ft_uint32_t options);
ft_void hal_spi_cmd_dlstart();
ft_void hal_spi_cmd_snapshot(ft_uint32_t ptr);
ft_void hal_spi_cmd_screensaver();
ft_void hal_spi_cmd_memcrc(ft_uint32_t ptr, ft_uint32_t num, ft_uint32_t result);

#endif /*  _FT_COPRO_CMDS_H_*/
